SystemOrganization addCategory: #'IRDA2013-Searching'!

CircleMorph subclass: #I2SVisualNode
	instanceVariableNames: 'node parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:30:51.012'!
newWithNode: aNode
	| a |
	a := self new.
	"a openInWorld."
	a position: 300@60.
	a node: aNode.
	a draw.
	a drawChildren. 

	^a! !

!I2SVisualNode class methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:33:17.713'!
newWithNode: aNode parent: aMorph
	| a |
	a := self new.
	a parent: aMorph.
	a parent addMorph: a.
"	a openInWorld."
	a position: 300@60.
	a node: aNode.
	a draw.
	a drawChildren. 

	^a! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:05.294'!
draw
	self color: self node value! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:34:46.241'!
drawChildren 
	| node pos |
	node := self node.
	pos := 0.
	(node children select: [:ea | ea notNil ]) 
		do: [ :child || a |
			a := self class newWithNode: child parent: self parent.
			a position: (self position translateBy: 
				pos@100).
			self parent addMorph: (LineMorph 
				from: self bounds bottomCenter 
				to: a bounds topCenter
				color: Color black 
				width: 5). 
			pos := pos + 100.		
		]! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:50.635'!
node
 ^node! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:44:54.969'!
node: aNode
 node := aNode! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:37.503'!
parent
	^parent! !

!I2SVisualNode methodsFor: 'as yet unclassified' stamp: 'sebastian.stamm 5/8/2013 10:32:27.117'!
parent: aMorph
	parent := aMorph.! !

Object subclass: #I2STestNode
	instanceVariableNames: 'value children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:37:45.65'!
children
	^children! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:00.496'!
children: anOrderedCollection
	children := anOrderedCollection! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:38:05.751'!
initialize

	self children: OrderedCollection new! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:05.903'!
value 
 ^value! !

!I2STestNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:39:11.427'!
value: aValue
 value := aValue! !

Object subclass: #I2STreeNode
	instanceVariableNames: 'children numChildren values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-Searching'!

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:45.175'!
addChild: newRoot at: position

[children size < position] whileTrue: [
	children add: nil].

(children at: position) ifNil: [
	children at: position put: newRoot.
	self addedChild: newRoot to: self at: position.
	numChildren := numChildren+1.
	]! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:42:15.911'!
addedChild: newRoot to: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:07.532'!
children

^children! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:12.897'!
getChild: position

children size >= position ifTrue: [
	^children at: position] ifFalse: [
	^nil]! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:17.325'!
getValue: position

(values size >= position) ifTrue: [
	^values at: position.] ifFalse:[
	^nil.
	]! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:24.062'!
hasChildren

^numChildren > 0! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:37.869'!
initialize

children := OrderedCollection new.
values := OrderedCollection new.
numChildren := 0.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:30.94'!
numChildren

^numChildren! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:41:55.328'!
removeChild: position

children size >= position ifTrue: [
	(children at: position) ifNotNil:[
		| child |
		child := children at: position.
		children at: position put: nil.
		self removed: child from: self at: position.
		numChildren := numChildren-1.]]! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:42:22.273'!
removed: root from: parent at: position

self emit.! !

!I2STreeNode methodsFor: 'as yet unclassified' stamp: 'benjamin.siegmund 5/2/2013 15:42:07.482'!
setValue: aValue at: position

[values size < position] whileTrue: [
	values add: nil].

values at: position put: aValue.! !
